using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace Nebula
{
    public class FYRequestModel
    {
        [System.Serializable]
        public class BaseParams
        {
            public string company_id = "";
            public string app_id = "";
            public string channel_id = "";
            public string union_id = "";
            public string open_id = "";
            public string device_id = "";
            public string startup_id = "";
            public string payment_code = "";
            public string passport_code = "";
            public int os = 0; // 假设os为0代表未知或未指定的操作系统
            public string network_mode = "";
            public string device_type = "";
            public string os_version = "";
            public string sdk_version = "";
            public string game_version = "";
            public string timestamp = ""; // 通常timestamp是时间戳，这里默认为空字符串，实际使用时需要替换为有效时间戳
            public int is_debug = 0; // 假设0代表非调试模式
            public string data_version = "";
            public string sign = "";
            public string sign_type = "";
            public string sign_nonce = "";
            public string sign_version = "";
        }

        [System.Serializable]
        public class UserDetail : BaseParams
        {
            public string user_id = "";
            public string code = "";
        }

        [System.Serializable]
        public class OrderCreate : BaseParams
        {
            public string pay_amount = "";
            public string game_order_id = "";
            public string goods_id = "";
            public string goods_name = "";
            public string player_id = "";
            public string role_id = "";
            public string player_name = "";
            public string player_level = "";
            public string vip_level = "";
            public string server_id = "";
            public string user_id = ""; // 注意这个user_id在BaseParams中也有定义，这里的定义会覆盖BaseParams中的
            public string pay_sign_type = "";
            public string notify_url = "";
            public string notify_ext = "";
            public int payment_channel = 0; // 假设0代表未指定支付渠道
            public string channel_ext = "";
        }
    }
}