using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace Nebula
{
    public class FYResponseModel
    {
        [System.Serializable]
        public class BaseResponse<T>
        {
            public int status = 0; // 通常HTTP状态码的默认值是200，但这里使用0作为默认值
            public T data = default(T); // 使用default(T)来设置泛型类型的默认值
            public string message = "";
        }

        [System.Serializable]
        public class UserDetail
        {
            public string union_id = "";
            public string open_id = "";
            public string token = "";
            public User user = new User(); // 创建User类的实例作为默认值
        }

        [System.Serializable]
        public class User
        {
            public string u_id = "";
            public string user_id = "";
        }

        [System.Serializable]
        public class OrderCreate
        {
            public string order_id = "";
            public string notify_url = "";
        }

        [System.Serializable]
        public class PayConfig
        {
            public string name = "";
            public PayConfigParam param = new PayConfigParam(); // 创建PayConfigParam类的实例作为默认值
        }

        [System.Serializable]
        public class PayConfigParam
        {
            public string android_pay_mode = "";
            public string android_close_pay_guide = "";
            public string ios_pay_mode = "";
            public string ios_close_pay_guide = "";
        }
    }
}