using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace Nebula
{
    public class NebulaSDKBridgeCallback : MonoBehaviour
    {
        public static Action<NebulaSDKInitInfo> InitCallback;
        public static Action<NebulaSDKLoginInfo> LoginCallback;
        public static Action<NebulaSDKPayInfo> PayCallback;
        public static Action<NebulaSDKOnShowInfo> OnShow;

        // 初始化回调
        void NebulaSDKInitCallback(string infoJson)
        {
            Debug.Log("###Init callback:" + infoJson);

            var info = JsonUtility.FromJson<NebulaSDKInitInfo>(infoJson);
            InitCallback?.Invoke(info);
        }

        // 登录回调
        void NebulaSDKLoginCallback(string infoJson)
        {
            Debug.Log("###login callback:" + infoJson);

            var info = JsonUtility.FromJson<NebulaSDKLoginInfo>(infoJson);
            LoginCallback?.Invoke(info);
        }

        // 支付回调
        void NebulaSDKPayCallback(string infoJson)
        {
            Debug.Log("###pay callback:" + infoJson);

            var info = JsonUtility.FromJson<NebulaSDKPayInfo>(infoJson);
            PayCallback?.Invoke(info);
        }
    }
}
