using System;
namespace Nebula
{
    [System.Serializable]
    public class NebulaSDKConfig
    {
        public string nbAppId = "";
        public string nbChannelId = "";
        public string nbChannelTemplateId = "";
        public string nbChannelTemplateCode = "";
        public string passportCode = "";
        public string paymentCode = "";
        public string env = "";
    }

    [System.Serializable]
    public class NebulaSDKInitInfo
    {
        public string status = "";
        public int code = 0;
        public NebulaSDKInitData data = new NebulaSDKInitData();
        public string msg = "";
    }

    [System.Serializable]
    public class NebulaSDKInitData
    {
        public string nbAppId = "";
        public string nbChannelId = "";
    }

    [System.Serializable]
    public class NebulaSDKLoginInfo
    {
        public string status = "";
        public int code = 0;
        public NebulaSDKLoginData data = new NebulaSDKLoginData();
        public string msg = "";
    }

    [System.Serializable]
    public class NebulaSDKLoginData
    {
        // 小游戏账号 OpenId，例如微信则对应微信 OpenId
        public string openId = "";
        // 小游戏账号 UnionId，例如微信则对应微信 UnionId
        public string unionId = "";
        // 星云登录 Token 
        public string token = "";
        // 星云账号 OpendId （废弃）
        public string nbOpendId = "";
        // 星云账号 OpenId 
        public string nbOpenId = "";
        // 星云账号 unionId 
        public string nbUnionId = "";
    }

    [System.Serializable]
    public class NebulaSDKPayInfo
    {
        public string status = "";
        public int code = 0;
        public NebulaSDKPayData data = new NebulaSDKPayData();
        public string msg = "";
    }

    [System.Serializable]
    public class NebulaSDKPayData
    {
        // 支付方式，1=原生支付、2=客服支付、3=二维码支付
        public int payType = 0;
        // 星云订单号   
        public string orderNo = "";
    }

    [System.Serializable]
    public class NebulaSDKOnShowInfo
    {
        public string status = "";
        public int code = 0;
        public NebulaSDKOnShowData data = new NebulaSDKOnShowData();
        public string msg = "";
    }

    [System.Serializable]
    public class NebulaSDKOnShowData
    {
        // 是否支持侧边栏
        public bool supportSideBar = false;
        // 是否从侧边栏进入
        public bool fromSideBar = false;
        // 是否推荐流直出场景
        public bool isFeedGameScene = false;
        // 推荐流直出的具体场景值
        public int feedGameScene = 0;
        // 推荐流直出的开发者自定义字段
        public string feedGameExtra = "";
    }
}