﻿using UnityEngine;
using System.Collections;

public class FYUIHelper
{
    /// <summary>
    ///  查找子GameObject的组件
    /// </summary>
    /// <typeparam name="T"></typeparam>
    /// <param name="gameObject"></param>
    /// <param name="childName"></param>
    /// <returns></returns>
    public static T FindChildGameObject<T>(GameObject gameObject, string childName) where T : Component
    {
        T[] ts = gameObject.GetComponentsInChildren<T>();
        foreach (var t in ts)
        {
            if (t.gameObject.name == childName)
            {
                return t;
            }
        }

        Debug.LogWarning($"在{gameObject}物体当中没有找到{childName}物体!");
        return null;
    }

    /// <summary>
    ///
    /// 获取场景中的canvas
    /// </summary>
    /// <returns></returns>
    public static GameObject FindCanvas()
    {
        GameObject gameObject = GameObject.FindObjectOfType<Canvas>().gameObject;
        if (gameObject == null)
        {
            Debug.LogError("没有在场景里面找到Canvas");
            return gameObject;
        }
        return gameObject;
    }
}

