using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;


public class GameController : MonoBehaviour
{
    private Text LogText;

    // Start is called before the first frame update
    void Start()
    {
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "NavigateToSideBar").onClick.AddListener(NavigateToSideBar);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "DoLogout").onClick.AddListener(DoLogout);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "DoPay").onClick.AddListener(DoPay);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "CreateShortcut").onClick.AddListener(CreateShortcut);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "ServiceXiao6").onClick.AddListener(ServiceXiao6);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "ServiceIM").onClick.AddListener(ServiceIM);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "RequestFeedSubscribe").onClick.AddListener(RequestFeedSubscribe);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "ReportScene").onClick.AddListener(ReportScene);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "ShowReward").onClick.AddListener(ShowReward);
        this.LogText = FYUIHelper.FindChildGameObject<Text>(this.gameObject, "LogText");
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "PrintParams").onClick.AddListener(PrintParams);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "CleanLog").onClick.AddListener(CleanLog);

        SDKManager.Instance.QueryLocalProducts();

        SDKManager.Instance.LoadReward();
    }

    // Update is called once per frame
    void Update()
    {
        this.LogText.text = LogManager.Instance.Log;
    }

    private void NavigateToSideBar()
    {
        SDKManager.Instance.NavigateToSideBar();
    }

    private void DoLogout()
    {
        SDKManager.Instance.DoLogout();
    }

    private void DoPay()
    {
        SDKManager.Instance.DoPay();
    }

    private void CreateShortcut()
    {
        SDKManager.Instance.CreateShortcut();
    }

    private void RequestFeedSubscribe()
    {
        SDKManager.Instance.RequestFeedSubscribe();
    }

    private void ServiceXiao6()
    {
        SDKManager.Instance.ServiceXiao6();
    }

    private void ServiceIM()
    {
        SDKManager.Instance.ServiceIM();
    }

    private void ReportScene()
    {
        SDKManager.Instance.ReportScene();
    }

    private void ShowReward()
    {
        SDKManager.Instance.ShowReward();
    }

    private void PrintParams()
    {
        LogManager.Instance.PrintParams();
    }

    private void CleanLog()
    {
        LogManager.Instance.Clean();
    }
}
