using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class LogManager
{
    public string Log = "";

    private static LogManager instance;

    public static LogManager Instance
    {
        get
        {
            if (instance == null)
            {
                instance = new LogManager();
            }
            return instance;
        }
    }

    private LogManager()
    {
        
    }

    public void Add(string log)
    {
        Debug.Log(log);
        DateTime now = DateTime.Now;
        string timeString = now.ToString("HH:mm:ss");
        Log = $"{timeString} {log}\n" + Log;
    }

    public void Clean()
    {
        Log = "";
    }

    public void PrintParams()
    {
        DateTime now = DateTime.Now;
        string timeString = now.ToString("HH:mm:ss");

        string paramsString =

            $"GameVersion(游戏版本)：{SDKManager.GameVersion}\n" +
            $"AppId(APP ID): {SDKManager.Instance.AppId}\n" +
            $"ChannelId(渠道ID): {SDKManager.Instance.ChannelId}\n" +
            $"ChannelTemplateId(渠道模板ID): {SDKManager.Instance.ChannelTemplateId}\n" +
            $"ChannelTemplateCode(渠道模板标识): {SDKManager.Instance.ChannelTemplateCode}\n" +
            $"PassportCode(通行证标识): {SDKManager.Instance.PassportCode}\n" +
            $"PaymentCode(支付标识): {SDKManager.Instance.PaymentCode}\n" +
            $"DeviceId(设备ID): {SDKManager.Instance.DeviceId}\n" +
            $"OpenId(聚合Open ID): {SDKManager.Instance.LoginSuccessInfo.data.nbOpendId}\n" +
            $"UnionId(聚合Union ID): {SDKManager.Instance.LoginSuccessInfo.data.nbUnionId}\n" +
            $"SDKVersion: {SDKManager.Instance.SDKVersion}\n" +
            $"Host: {SDKManager.Instance.Host}\n";
        Log = $"{timeString} ###\n{paramsString}\n{Log}";

    }
}
